Index: branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfswm.F90
===================================================================
--- branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfswm.F90	(revision 8054)
+++ branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfswm.F90	(revision 8055)
@@ -27,4 +27,6 @@
    PUBLIC zdf_swm_init    ! routine called in zdf_phy_init
 
+   !! * Substitutions
+#  include "domain_substitute.h90"   
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2017) 
@@ -34,5 +36,5 @@
 CONTAINS
 
-   SUBROUTINE zdf_swm( kt )
+   SUBROUTINE zdf_swm( ARG_2D, kt, p_avm, p_avt, p_avs )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE zdf_swm ***
@@ -51,5 +53,8 @@
       !! reference : Qiao et al. GRL, 2004
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt   ! ocean time step
+      INTEGER                    , INTENT(in   ) ::   ARG_2D         ! inner domain start-end i-indices
+      INTEGER                    , INTENT(in   ) ::   kt             ! ocean time step
+      REAL(wp), DIMENSION(:,:,:) , INTENT(inout) ::   p_avm          ! momentum Kz (w-points)
+      REAL(wp), DIMENSION(:,:,:) , INTENT(inout) ::   p_avt, p_avs   ! tracer   Kz (w-points)
       !
       INTEGER ::   ji, jj, jk   ! dummy loop indices
@@ -59,11 +64,11 @@
       zcoef = 1._wp * 0.353553_wp
       DO jk = 2, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1
+         DO jj = k_Jstr, k_Jend
+            DO ji = k_Istr, k_Iend
                zqb = zcoef * hsw(ji,jj) * tsd2d(ji,jj) * EXP( -3. * wnum(ji,jj) * gdepw_n(ji,jj,jk) ) * wmask(ji,jj,jk)
                !
-               avt(ji,jj,jk) = avt(ji,jj,jk) + zqb
-               avs(ji,jj,jk) = avs(ji,jj,jk) + zqb
-               avm(ji,jj,jk) = avm(ji,jj,jk) + zqb
+               p_avt(ji,jj,jk) = p_avt(ji,jj,jk) + zqb
+               p_avs(ji,jj,jk) = p_avs(ji,jj,jk) + zqb
+               p_avm(ji,jj,jk) = p_avm(ji,jj,jk) + zqb
             END DO
          END DO
